      Subroutine GPBCam()

      USE IFQWIN
      Use Global
      Use DialogScroll

      IMPLICIT NONE

      Integer :: RESULT,I,J,N,Error,Num
      Integer :: ThetaOP,ThetaCL,Tel,TelZero,TelMaxL
      Integer :: NumULR,NumUR,NumUL,NumUDW,NumDLR,NumDR,NumDL,NumDDW,NumOP,NumTot

      Real(8) :: KR0,KR1,KR2,KR3,KR4,KR5,KR6
      Real(8) :: KM0,KM1,KM2,KM3,KM4
      Real(8) :: ThetaUL,ThetaUDW,ThetaDDW,ThetaDL,ThetaS
      Real(8) :: VEL(0:8000),ACC(0:8000)
      Real(8) :: CLTAP,Area,LiftOld
      Real(8) :: L(0:8000),LN(0:8000),Deg(0:8000)
      Real(8) :: C(0:100),M(0:100)
      Real(8) :: LTemp(0:100),ThetaTemp(100)

      Error=1

100   Call DialogGenerate ()

      If(Ans .eq. 0)Return

      CamDeg=1
      Write(21,*)
      Write(21,*)'1  Valve open Duration (deg)........................= ',ThetaV
      Write(21,*)'2  Lobe Centre after start of lift (deg)............= ',ThetaLC
      Write(21,*)'3  Valve lift in mm.................................= ',LV
      Write(21,*)'4  Valve clearance in mm............................= ',LashClear
      Write(21,*)'5  Opening Ramp duration (deg)......................= ',ThetaULR
      Write(21,*)'6  Closing Ramp duration (deg)......................= ',ThetaDLR
      Write(21,*)'7  Opening Positive Acceleration ratio (0.2 to 0.5).= ',CUR
      Write(21,*)'8  Closing Positive Acceleration ratio (0.2 to 0.5).= ',CDR
      Write(21,*)'9  Dwell angle (deg)................................= ',ThetaDW
      Write(21,*)'10 Opening Positive Acceleration duration (deg).....= ',ThetaUR
      Write(21,*)'11 Closing Positive Acceleration duration (deg).....= ',ThetaDR
      Write(21,*)
      Write(21,*)'IgnitionType = ',IgnitionType
      Write(21,*)

! Blair values

      If(IgnitionType .eq. 'Spark')Then
      
        !40deg
        KR0= 0.011172
        KR1=-0.080336
        KR2= 0.468600
        KR3= 0.611900
        
        !20deg
        !KR0= 0.000150
        !KR1= 0.474000
        !KR2= 0.573300
        !KR3=-0.045900
        
        KR4= 0.0
        KR5= 0.0
        KR6= 0.0
      
      ElseIf(IgnitionType .eq. 'Compr')Then

        KR0=-0.00018552
        KR1= 0.045892
        KR2= 1.979500
        KR3=-1.025600
        KR4= 0.0
        KR5= 0.0
        KR6= 0.0

      EndIf

! Blair values

      If(IgnitionType .eq. 'Spark')Then
      
        KM0=-0.007858
        KM1= 1.767300
        KM2=-0.451610
        KM3=-0.311580
        KM4= 0.0
        
      ElseIf(IgnitionType .eq. 'Compr')Then

        KM0=-0.0006083
        KM1= 1.923600
        KM2=-0.841220
        KM3=-0.082123
        KM4= 0.0

      EndIf

      CLTAP=LashClear

!      ThetaV  =VC+VO+180
      If(ThetaLC .eq. 0.0)Then
        ThetaLC =ThetaV/2
      EndIf
      ThetaUDW=ThetaDW/2
      ThetaDDW=ThetaDW/2
      ThetaUL =ThetaLC-(ThetaUDW+ThetaUR)
      ThetaDL =(ThetaV-ThetaLC)-(ThetaDR+ThetaDDW)
      ThetaOP =INT(ThetaUR+ThetaUL+ThetaUDW)
      ThetaCL =INT(ThetaV-ThetaOP)

      LUR = CUR*LV
      LDR = CDR*LV

      If(Error .eq. 1)Then
        Write(21,*)
        Write(21,*)'ThetaV  =',ThetaV
        Write(21,*)'ThetaUR =',ThetaUR
        Write(21,*)'ThetaDR =',ThetaDR
        Write(21,*)'ThetaUL =',ThetaUL
        Write(21,*)'ThetaDL =',ThetaDL
        Write(21,*)'ThetaUDW=',ThetaUDW
        Write(21,*)'ThetaDDW=',ThetaDDW
        Write(21,*)'ThetaOP =',ThetaOP
        Write(21,*)'ThetaCL =',ThetaCL
        Write(21,*)'LUR     =',LUR
        Write(21,*)'LDR     =',LDR
      EndIf

!      Write(21,*)'ThetaV= ',ThetaV,' ThetaUL= ',ThetaUL

      NumULR=INT(ThetaULR)
      NumUR =INT(ThetaUR)
      NumUL =INT(ThetaUL)
      NumUDW=ThetaOP-NumUR-NumUL

      NumDLR=INT(ThetaDLR)
      NumDR =INT(ThetaDR)
      NumDL =INT(ThetaDL)
      NumDDW=ThetaCL-NumDR-NumDL

      If(Error .eq. 1)Then
        Write(21,*)
        Write(21,*)'NumULR =',NumULR
        Write(21,*)'NumUR  =',NumUR
        Write(21,*)'NumUL  =',NumUL
        Write(21,*)'NumUDW =',NumUDW
        Write(21,*)'  '
        Write(21,*)'NumDLR =',NumDLR
        Write(21,*)'NumDR  =',NumDR
        Write(21,*)'NumDL  =',NumDL
        Write(21,*)'NumDDW =',NumDDW
        Write(21,*)
      EndIf

      !Zero all values
      Do N=0,500
        Theta(N)=0.0
        L(N)    =0.0
        CV(N)   =0.0
        GV(N)   =0.0
      EndDo

! Start - base circle

      If(Error .eq. 1)Write(21,*)'STARTING BASE CIRCLE'

      I       =0
      N       =I
      Tel     =0
      L(N)    =0.0
      Theta(N)=I
      C(0)    =0

      If(Error .eq. 1)Write(21,*)Theta(N),L(N)
      
 ! valve clearance ramp
 
      If(NumULR .gt. 0)Then
        Do I=1,5
          N=N+1
          C(N)=L(N-1)-N*(N-1)*LashClear/(5*(NumULR-N))
          L(N)=(N**2*LashClear/5)/(NumULR-(N-1))+C(N)
          Write(21,*)'  ',N,C(N),L(N)
          Theta(N)=N
          Num=N
          If(Error .eq. 1)Write(21,*)I,Theta(N),L(N)
        EndDo
        Do I=6,NumULR
          N=N+1
          L(N)=(Num*N*LashClear/5)/(NumULR-(Num-1))+C(Num)
          Theta(N)=N
          If(Error .eq. 1)Write(21,*)I,Theta(N),L(N)
        EndDo
      EndIf

! Up ramp

      If(Error .eq. 1)Write(21,*)'UP RAMP  ',NumUR

      TelZero=0

      Do I=0,NumUR-1
        N       =N+1
        ThetaS  =I/ThetaUR
        LS      =KR0+KR1*ThetaS+KR2*ThetaS**2+KR3*ThetaS**3+KR4*ThetaS**4+KR5*ThetaS**5
        L(N)    =LUR*LS+LashClear
        If(L(N) .le. L(N-1))TelZero=TelZero+1
        Theta(N)=N
        If(Error .eq. 1)Write(21,*)I,Theta(N),L(N) 
      EndDo

      Do I=Tel+1,Tel+TelZero
        L(I)=L(Tel+TelZero+1)/(TelZero+Tel-I+2)
      EndDo

      Do I=Tel+1,Tel+NumUR
        !If(Error .eq. 1)Write(21,*)I,Theta(I),L(I)
      EndDo

! Up main lift

      If(Error .eq. 1)Write(21,*)'MAIN LIFT ',NumUL

      Do I=1,NumUL-1
        N       =N+1
        ThetaS  =I/(ThetaUL-1)
        LS      =KM0+KM1*ThetaS+KM2*ThetaS**2+KM3*ThetaS**3+KM4*ThetaS**4
        L(N)    =LUR+(LV-LUR)*LS+LashClear
        If(L(N).lt.L(N-1))L(N)=(L(N-1)+(LV+LashClear-L(N-1))/(2+NumUL-I))
        If(L(N) .gt. (LV+LashClear))L(N)=(LV+LashClear)
        Theta(N)=N
        If(Error .eq. 1)Write(21,*)I,Theta(N),L(N) 
      EndDo


! Dwell

! Up Dwell

      If(Error .eq. 1)Write(21,*)'DWELL     ',ThetaDW

      If(ThetaUDW.NE.0.0)Then
        If(Error .eq. 1)Write(21,*)'UP DWELL  ',NumUDW
        Do I=1,NumUDW
          N       =N+1
          L(N)    =LV+LashClear
          Theta(N)=N
          If(Error .eq. 1)Write(21,*)I,Theta(N),L(N)
        EndDo
      EndIf

      NumOP=N

! Static center point

      N=N+1
      Theta(N)=N
      L(N)=LV+LashClear
      TelMaxL = N
      If(Error .eq. 1)Write(21,*)'Center Point, TelMaxL = ',TelMaxL
      If(Error .eq. 1)Write(21,*)N,Theta(N),L(N)

! Down Dwell

      If(ThetaDDW.NE.0.0)Then
        If(Error .eq. 1)Write(21,*)'DOWN DWELL',NumDDW
        Do I=1,NumDDW
          N       =N+1
          L(N)    =LV+LashClear
          Theta(N)=N
          If(Error .eq. 1)Write(21,*)I,Theta(N),L(N),N
        EndDo
      EndIf

! Down main lift

      If(Error .eq. 1)Write(21,*)'MAIN DOWN LIFT ',NumDL

      Do I=1,NumDL-1
        N       =N+1
        ThetaS  =(NumDL-I)/(ThetaDL-1)
        LS      =KM0+KM1*ThetaS+KM2*ThetaS**2+KM3*ThetaS**3+KM4*ThetaS**4
        L(N)    =LDR+(LV-LDR)*LS+LashClear
        Theta(N)=N
      EndDo

      Do I=N-1,N-NumDL+2,-1
        J=N-I
        If(L(I).LT.L(I+1))L(I)=(L(I+1)+(LV+LashClear-L(I+1))/(1+NumDL-J))
        If(L(I) .gt. (LV+LashClear))L(I)=(LV+LashClear)
      EndDo

      If(Error .eq. 1)Then
        Do I=N-NumDL+2,N
          Write(21,*)I,Theta(I),L(I)
        EndDo
      EndIf

! Down ramp

      If(Error .eq. 1)Write(21,*)'DOWN RAMP  ',NumDR

      TelZero=0

      Do I=1,NumDR
        N       =N+1
        ThetaS  =1-I/ThetaDR
        LS      =KR0+KR1*ThetaS+KR2*ThetaS**2+KR3*ThetaS**3+KR4*ThetaS**4+KR5*ThetaS**5
        L(N)    =LDR*LS+LashClear
        If(L(N-1) .le. L(N))TelZero=N
        Theta(N)=N
        If(Error .eq. 1)Write(21,*)I,Theta(N),L(N)
      EndDo
      
 ! valve clearance ramp
 
      If(NumDLR .gt. 0)Then
        If(Error .eq. 1)Write(21,*)'Lash Ramp  ',NumDLR
        LTemp(0)=0.0
        Do I=1,5
          C(I)=Ltemp(I-1)-I*(I-1)*LashClear/(5*(NumDLR-I))
          Ltemp(I)=(I**2*LashClear/5)/(NumULR-(I-1))+C(I)
          Write(21,*)'  ',I,C(I),Ltemp(I)
          ThetaTemp(I)=I
          Num=I
          If(Error .eq. 1)Write(21,*)I,ThetaTemp(I),L(I)
        EndDo
        Do I=6,NumDLR
          Ltemp(I)=(Num*I*LashClear/5)/(NumDLR-(Num-1))+C(Num)
          ThetaTemp(I)=I
          If(Error .eq. 1)Write(21,*)I,ThetaTemp(I),Ltemp(I)
        EndDo
        Do I=1,NumDLR
          N=N+1
          L(N)=Ltemp(NumDLR-I+1)
          Theta(N)=N
          If(Error .eq. 1)Write(21,*)I,Theta(N),L(N)
        EndDo
      EndIf


! End - base circle

      If(Error .eq. 1)Write(21,*)'ENDING BASE CIRCLE'
      N       =N+1
      L(N)    =0.0
      Theta(N)=N
      NumTot  =N
      If(Error .eq. 1)Then
        Write(21,*)Theta(N),L(N)
        Write(21,*)'NumTot= ',NumTot
        Write(21,*)NumTot/2-1,NumTot/2+1
      EndIf

! Smoothing
      
      !Smooth lift profile
      LiftOld = L(NumULR)
      Do I=1,100
        Do N=NumULR+1,NumTot-NumDLR-1
          LN(N)=((L(N+1)+L(N-1))/2)
        EndDo
        Do N=NumULR+1,NumTot-NumDLR-1
          L(N)=LN(N)*(LV+LashClear)/LN(TelMaxL)
        EndDo
      EndDo

      !Smooth ramp/uplift interface
      If(NumULR .gt. 3)Then
        Do I=1,5
          !Do N=NumULR-3,NumULR+3
          Do N=1,NumULR+3
            LN(N)=((L(N+1)+L(N-1))/2)
          EndDo
          !Do N=NumULR-3,NumULR+3
          Do N=1,NumULR+3
            L(N)=LN(N)*(LV+LashClear)/LN(TelMaxL)
          EndDo
        EndDo
      EndIf

      !Smooth ramp/downlift interface
      If(NumULR .gt. 3)Then
        Do I=1,5
          Do N=NumTot-NumDLR-3,NumTot
            LN(N)=((L(N+1)+L(N-1))/2)
          EndDo
          Do N=NumTot-NumDLR-3,NumTot
            L(N)=LN(N)*(LV+LashClear)/LN(TelMaxL)
          EndDo
        EndDo
      EndIf

! Cam Area

      Area=0.0
      Do N=NumULR+1,NumTot-NumDLR-1
        Area=Area+(L(N)-LashClear)
        If(Error .eq. 1)Write(21,*)Theta(N),L(N)
      EndDo

! Velocity

      CV(0)     =0.0
      CV(NumTot)=0.0
      Do N=1,NumTot-1
        CV(N)=(L(N+1)-L(N-1))/(Theta(N+1)-Theta(N-1))
      EndDo

! Acceleration

      GV(0)     =0.0
      GV(NumTot)=0.0
      Do N=2,NumTot-2
        GV(N)=(CV(N+1)-CV(N-1))/(Theta(N+1)-Theta(N-1))
      EndDo
      GV(1)       =GV(2)/2
      GV(NumTot-1)=GV(NumTot-2)/2

! Jerk

      JV(0)       =0.0
      JV(NumTot)  =0.0
      Do N=1,NumTot-1
        JV(N)=((GV(N+1)-GV(N-1)))/(Theta(N+1)-Theta(N-1))
      EndDo

      If(Error .eq. 1)Then
        Write(21,*)
        Write(21,'(A)')'Deg          Lift            Vel            Acc            Jerk'
        Do N=0,NumTot
          Write(21,'(F6.2,4x,4(F12.9,4x))')Theta(N),L(N),CV(N),GV(N),JV(N)
        EndDo
      EndIf

! Determine actual opening and closing time incorporating tappet clearance

      Tel=0
      Do I=0,500
        If(L(I) .ge. CLTAP)Then
          If(CLTAP .le. 0.0)Then
            ThetaOPAC=Theta(0)
            Tel=1
          Else
            ThetaOPAC=Theta(I-1)+(Theta(I)-Theta(I-1))*(CLTAP-L(I-1))/(L(I)-L(I-1))
            Tel=I+1
          EndIf
          !ThetaOPAC=Theta(I)
          Tel=I+1
          Goto 802
        EndIf
      EndDo
      

802   Do I=Tel,500
        If(L(I) .le. CLTAP)Then
          If(CLTAP .le. 0.0 .and. L(I) .le. 0.0)Then
            ThetaCLAC=Theta(I)
          Else
            ThetaCLAC=Theta(I-1)+(Theta(I)-Theta(I-1))*(CLTAP-L(I-1))/(L(I)-L(I-1))
          EndIf
          !ThetaCLAC=Theta(I)
          Goto 803
        EndIf
      EndDo

! Determine 1mm (40thou) opening and closing time incorporating tappet clearance

803   Tel=0
      Do I=0,500
        If(L(I) .ge. CLTAP+1.0)Then
          ThetaOP1mm=Theta(I-1)+(Theta(I)-Theta(I-1))*((CLTAP+1.0)-L(I-1))/(L(I)-L(I-1))
          !ThetaOP1mm=Theta(I)
          Tel=I+1
          Goto 804
        EndIf
      EndDo
      

804   Do I=Tel,500
        If(L(I) .le. CLTAP+1.0)Then
          ThetaCL1mm=Theta(I-1)+(Theta(I)-Theta(I-1))*((CLTAP+1.0)-L(I-1))/(L(I)-L(I-1))
          !ThetaCL1mm=Theta(I)
          Goto 805
        EndIf
      EndDo

! Determine 1.25mm (50thou) opening and closing time incorporating tappet clearance

805   Tel=0
      Do I=0,500
        If(L(I) .ge. CLTAP+1.25)Then
          ThetaOP125mm=Theta(I-1)+(Theta(I)-Theta(I-1))*((CLTAP+1.25)-L(I-1))/(L(I)-L(I-1))
          !ThetaOP125mm=Theta(I)
          Tel=I+1
          write(21,*)'Tel = ',Tel
          Goto 806
        EndIf
      EndDo
      

806   Do I=Tel,500
        If(L(I) .le. CLTAP+1.25)Then
          ThetaCL125mm=Theta(I-1)+(Theta(I)-Theta(I-1))*((CLTAP+1.25)-L(I-1))/(L(I)-L(I-1))
          !ThetaCL125mm=Theta(I)
          write(21,*)'Tel = ',Tel
          Goto 807
        EndIf
      EndDo

! Determine UserLiftOutput mm opening and closing time incorporating tappet clearance

807   Tel=0
      Do I=0,500
        If(UserLiftOutput .eq. 0.0)UserLiftOutput = 5.08
        If(L(I) .ge. CLTAP+UserLiftOutput)Then
          ThetaOP_User=Theta(I-1)+(Theta(I)-Theta(I-1))*((CLTAP+UserLiftOutput)-L(I-1))/(L(I)-L(I-1))
          !ThetaOP_User=Theta(I)
          Tel=I+1
          Goto 808
        EndIf
      EndDo
      

808   Do I=Tel,500
        If(L(I) .le. CLTAP+UserLiftOutput)Then
          ThetaCL_User=Theta(I-1)+(Theta(I)-Theta(I-1))*((CLTAP+UserLiftOutput)-L(I-1))/(L(I)-L(I-1))
          !ThetaCL_User=Theta(I)
          Goto 810
        EndIf
      EndDo

810   If(Error .eq. 1)Then
        Write(21,*)
        Write(21,*)'ThetaOPAC    = ',ThetaOPAC
        Write(21,*)'ThetaCLAC    = ',ThetaCLAC
        Write(21,*)'ThetaOP1mm   = ',ThetaOP1mm
        Write(21,*)'ThetaCL1mm   = ',ThetaCL1mm
        Write(21,*)'ThetaOP125mm = ',ThetaOP125mm
        Write(21,*)'ThetaCL125mm = ',ThetaCL125mm
        Write(21,*)'ThetaOP_User = ',ThetaOP_User
        Write(21,*)'ThetaCL_User = ',ThetaCL_User
        Write(21,*)
      EndIf

! Write the ENGINE degrees versus lift, velocity, and acceleration

      If(CamDeg .eq. 1)Then

        Write(21,10)Theta(0),L(0),CV(0),GV(0),JV(0)

        Deg(0) =Theta(0)
        Lift(0)=L(0)
        VEL(0) =0.0
        ACC(0) =0.0
        Jerk(0)=0.0

        !Do I=1,ThetaCLAC-ThetaOPAC,1
        Do I=1,NumTot,1

          Write(21,10)Theta(I),(L(I+ThetaOPAC)),CV(I+ThetaOPAC),GV(I+ThetaOPAC),JV(I+ThetaOPAC)

          Deg(I) =Theta(I)
          !Lift(I)=L(I+ThetaOPAC)-CLTAP
          !VEL(I) =CV(I+ThetaOPAC)
          !ACC(I) =GV(I+ThetaOPAC)
          !Jerk(I)=JV(I+ThetaOPAC)
          Lift(I)=L(I)
          VEL(I) =CV(I)
          ACC(I) =GV(I)
          Jerk(I)=JV(I)

        EndDo

        !Num=ThetaCLAC-ThetaOPAC
        Num=NumTot

        Deg(Num) =Num
        Lift(Num)=L(0)
        VEL(Num) =0.0
        ACC(Num) =0.0
        Jerk(Num)=0.0
      
!       Write(21,10)Theta(I),L(0),CV(0),GV(0)

      Else

! Write the CAM degrees versus lift, velocity, and acceleration

        Write(21,10)Theta(0),L(0),CV(0),GV(0)

        Deg(0) =Theta(0)
        Lift(0)=L(0)
        VEL(0) =0.0
        ACC(0) =0.0
        Jerk(0)=0.0

        !Do I=2,ThetaCLAC-ThetaOPAC,2
        Do I=2,NumTot,2
          Write(21,10)Theta(I)/2,(L(I+ThetaOPAC)-CLTAP),CV(I+ThetaOPAC),GV(I+ThetaOPAC),JV(I+ThetaOPAC)

          N      =I/2
          Deg(N) =Theta(I)/2
          Lift(N)=L(I+ThetaOPAC)-CLTAP
          VEL(N) =CV(I+ThetaOPAC)
          ACC(N) =GV(I+ThetaOPAC)
          Jerk(N)=JV(I+ThetaOPAC)

        EndDo

        !Num=(ThetaCLAC-ThetaOPAC-1)/2+1
        Num=(NumTot-1)/2+1

        Deg(I/2) =Num+1
        Lift(I/2)=L(0)
        VEL(I/2) =0.0
        ACC(I/2) =0.0
        Jerk(I/2)=0.0
      
!       Write(21,10)Theta(I)/2,L(0),CV(0),GV(0)

      EndIf

      !Max Lift position
      Do i=1,NumTot
        If(Lift(i) .gt. Lift(i-1))LiftCenter = Real(i)
      EndDo

      !Plot the generated curve
      DurationTotal = ThetaV+ThetaULR+ThetaDLR
      DurationClear = ThetaV
      LiftClear  = LV
      ValveOpen  = ThetaULR
      ValveClose = ThetaV+ThetaULR
      LobeOffset = 0.0
      CamType    = 'Exhst'
      NumInc     = Num
      CamArea    = Area
      PlotType   = ''
      PlotType   = 'Design'
      Call Dialog_Scroll()

      If(CamEdit .eqv. .False.)Return
      If(CamEdit .eqv. .True. )Goto 100

10    Format(2x,F6.2,2X,F10.7,2X,F10.7,2X,F10.7,2X,F10.7)

      Return
      End
!----------------------------------------------------------------------------------------------------




