MODULE GPBCams

USE Xeffort
USE IFWIN

IMPLICIT NONE

INCLUDE 'Resource.fd'

!========================================================================
CONTAINS
!========================================================================
!PURPOSE: Initialization function called by Xeffort library on app start.
LOGICAL FUNCTION XInit(szCmdLine,nCmdShow)

!DEC$ATTRIBUTES DEFAULT, DECORATE, ALIAS: 'XINIT':: XInit

IMPLICIT NONE

CHARACTER(*), INTENT(IN)::    szCmdLine
Character(len=35)       ::    Title 
Character(len=100)      ::    Text
Character(Len=10)       ::    Version

INTEGER, INTENT(IN)     ::    nCmdShow
INTEGER                 ::    Len

LOGICAL                 ::    bSt


       Version = 'V0.0.1'

       Title(1:22)     = "Test Beta, Version: "
       Len             = Len_Trim(Version)
       Title(23:23+Len)= Version


IF (XCreateDialogApp(IDD_MAIN, idIcon=IDI_ICON_MAIN)) THEN
 
	 bSt = XCtlSet(XW_FRAME, IDD_MAIN, Title, CTL_TITLE)

	 bSt = XCtlSetSub(XW_FRAME, IDCANCEL_INIT,        XW_FRAME_Initialize)
	 bSt = XCtlSetSub(XW_FRAME, IDC_Button_Continue,  XW_FRAME_Continue)
	 bSt = XCtlSetSub(XW_FRAME, IDC_Button_Init_Help, XW_FRAME_Initialize)

   IF (XModalDialog(XW_FRAME) .EQ. IDOK) THEN
   END IF
   
END IF

XInit = .FALSE.

END FUNCTION XInit
!================================================================================
Subroutine XW_FRAME_Initialize(xWnd, idCmd, nCode)

TYPE(X_WINDOW)      :: xWnd

Integer :: idCmd
Integer :: nCode

Integer             :: iSt
Logical             :: bSt

SELECT CASE(idCmd)

	 CASE (IDCANCEL_INIT)
	   !call XDestroyDialog to close application
	   CALL XDestroyDialog (xWnd)
	   STOP

	 CASE (IDC_Button_Init_Help)
	   !Call Help()

ENDSELECT

End Subroutine XW_FRAME_Initialize
!================================================================================
Subroutine XW_FRAME_Continue(xWnd, idCmd, nCode)

TYPE(X_WINDOW)      :: xWnd

Integer :: idCmd
Integer :: nCode

Integer             :: res
Integer             :: b
Integer             :: len

Logical             :: bSt

Character(Len = 80) :: str

      
            str = 'Write this string to a Xmessage box.'
            len = Len_Trim(str)
            res = XMessageBox(str(1:len),' Test 'C,MB_OK.OR.MB_IconInformation.or.MB_TopMost)
            
End Subroutine XW_FRAME_Continue
!========================================================================
END MODULE GPBCams

